zoukankan      html  css  js  c++  java
  • LeetCode 699. Falling Squares 掉落的方块 (Java)

    题目:

    On an infinite number line (x-axis), we drop given squares in the order they are given.

    The i-th square dropped (positions[i] = (left, side_length)) is a square with the left-most point being positions[i][0] and sidelength positions[i][1].

    The square is dropped with the bottom edge parallel to the number line, and from a higher height than all currently landed squares. We wait for each square to stick before dropping the next.

    The squares are infinitely sticky on their bottom edge, and will remain fixed to any positive length surface they touch (either the number line or another square). Squares dropped adjacent to each other will not stick together prematurely.

    Return a list ans of heights. Each height ans[i] represents the current highest height of any square we have dropped, after dropping squares represented by positions[0], positions[1], ..., positions[i].

    Example 1:

    Input: [[1, 2], [2, 3], [6, 1]]
    Output: [2, 5, 5]
    Explanation:
    

    After the first drop of positions[0] = [1, 2]: _aa _aa ------- The maximum height of any square is 2.

    After the second drop of positions[1] = [2, 3]: __aaa __aaa __aaa _aa__ _aa__ -------------- The maximum height of any square is 5. The larger square stays on top of the smaller square despite where its center of gravity is, because squares are infinitely sticky on their bottom edge.

    After the third drop of positions[1] = [6, 1]: __aaa __aaa __aaa _aa _aa___a -------------- The maximum height of any square is still 5. Thus, we return an answer of [2, 5, 5].

    Example 2:

    Input: [[100, 100], [200, 100]]
    Output: [100, 100]
    Explanation: Adjacent squares don't get stuck prematurely - only their bottom edge can stick to surfaces.

    Note:

    • 1 <= positions.length <= 1000.
    • 1 <= positions[i][0] <= 10^8.
    • 1 <= positions[i][1] <= 10^6.

    分析:

    简单来说这道题就是会在一个区域内掉落一些方块,给定掉落的起点和方块的边长,每掉落一个方块都要求得此时区域内最大的高度。

    由于方块之间有可能会叠加起来,例如[2,2],[3,1],这种情况当第二个方块到来之后,由于叠加,最大高度就变成了3.

    我们维护一个list,用来保存加入的方块所达到的最大高度,每新加入一个方块,就遍历list,找到和当前加入方块发生重叠的部分,计算重叠部分的最大高度,那么这个最大高度再加上方块的边长就是这个方块的最大高度了,再将这个方块的信息加入到list中,继续掉落方块即可。

    程序:

    class Solution {
        public List<Integer> fallingSquares(int[][] positions) {
            List<int[]> list = new ArrayList<>();
            List<Integer> res = new ArrayList<>();
            int maxHeight = Integer.MIN_VALUE;
            for(int[] arr:positions){
                int start = arr[0];
                int end = arr[0] + arr[1];
                //int[] interval = new int[]{arr[0], arr[0]+arr[1], arr[1]}; //{start, end, height}
                int tempHeight = 0;
                for(int[] interval:list){
                    if(end <= interval[0] || start >= interval[1])
                        continue;
                    tempHeight = Math.max(tempHeight, interval[2]);
                }
                int height = tempHeight + arr[1];
                list.add(new int[]{start, end, height});
                maxHeight = Math.max(maxHeight, height);
                res.add(maxHeight);
            }
            return res;
        }
    }
  • 相关阅读:
    无名信号量在多线程间的同步
    ftok函数例子
    strerror和perror函数详解
    lockf函数的使用
    背包问题-2动态规划【正解】
    递归思想即背包问题
    生产者消费者问题(基于线程和无名信号量)
    eclipse 安装python后pydev不出现
    Eclipse+pydev解决中文显示和注释问题的方法大全
    MyEclipse10配置PyDev进行Python开发
  • 原文地址:https://www.cnblogs.com/silentteller/p/12869247.html
Copyright © 2011-2022 走看看